Index: python/FlexpartTools.py
===================================================================
--- python/FlexpartTools.py	(revision 21938083773b1bba2e82ee565f34eba3445dfa1a)
+++ python/FlexpartTools.py	(revision e879023747fe27c7a7f54905ed6f8312aac6ac21)
@@ -827,5 +827,5 @@
         else:
             for ty,st,ti in zip(c.type,c.step,c.time):
-                btlist=range(24)
+                btlist=range(len(c.time))
                 if c.basetime=='12':
                     btlist=[1,2,3,4,5,6,7,8,9,10,11,12]
@@ -837,5 +837,5 @@
                    (ty.upper() != 'AN' and mod(int(c.step[i]),int(c.dtime))==0 and \
                     mod(int(c.step[i]),int(c.dtime))==0) ) and \
-                   (int(c.time[i]) in btlist or c.maxstep>24):
+                   (i in btlist or c.maxstep>24):
                     if ty not in self.types.keys():
                         self.types[ty]={'times':'','steps':''}
@@ -1155,4 +1155,8 @@
                         mftimesave=''.join(mftime)
 
+                        if pk=='OG_OROLSM__SL':
+                            mfdate=self.dates.split('/')[0]
+                            mftarget=self.inputdir+"/"+pk+'.'+mfdate+'.'+str(os.getppid())+'.'+str(os.getpid())+".grb"
+
                         if '/' in mftime:
                             times=mftime.split('/')
@@ -1163,4 +1167,11 @@
                                 else:
                                     mftime=times[0]
+
+                        if int(mftimesave.split('/')[0])==0 and int(mfstep.split('/')[0])==0 and pk!='OG_OROLSM__SL':
+                            mfdate=datetime.datetime.strftime(elimit,'%Y%m%d')
+                            mftime='00'
+                            mfstep='000'
+                            mftarget=self.inputdir+"/"+ftype+pk+'.'+mfdate+'.'+str(os.getppid())+'.'+str(os.getpid())+".grb"
+
                         # increase number of mars requests
                         self.mreq_count += 1
@@ -1179,26 +1190,4 @@
                             MR.displayInfo()
                             MR.dataRetrieve()
-
-                        if int(mftimesave.split('/')[0])==0 and int(mfstep.split('/')[0])==0 and pk!='OG_OROLSM__SL':
-                            mfdate=datetime.datetime.strftime(elimit,'%Y%m%d')
-                            mftime='00'
-                            mfstep='000'
-                            mftarget=self.inputdir+"/"+ftype+pk+'.'+mfdate+'.'+str(os.getppid())+'.'+str(os.getpid())+".grb"
-                            # increase number of mars requests
-                            self.mreq_count += 1
-                            MR= MARSretrieval(self.server, self.public, dataset=self.dataset, marsclass=self.marsclass, stream=self.stream,
-                                              type=mftype, levtype=pv[1], levelist=pv[2],resol=self.resol, gaussian=gaussian,
-                                          accuracy=self.accuracy,grid=pv[3],target=mftarget,area=area,
-                                          date=mfdate, time=mftime,number=self.number,step=mfstep, expver=self.expver, param=pv[0])
-
-                            if request == 0:
-                                MR.displayInfo()
-                                MR.dataRetrieve()
-                            elif request == 1:
-                                MR.print_infodata_csv(self.inputdir, self.mreq_count)
-                            elif request == 2:
-                                MR.print_infodata_csv(self.inputdir, self.mreq_count)
-                                MR.displayInfo()
-                                MR.dataRetrieve()
 
 
Index: python/getMARSdata.py
===================================================================
--- python/getMARSdata.py	(revision 5862eb9fb86828345e2b1eff400e37c52de16432)
+++ python/getMARSdata.py	(revision e879023747fe27c7a7f54905ed6f8312aac6ac21)
@@ -73,5 +73,5 @@
         del attrs['server']
         del attrs['public']
-        marsfile = os.path.join(c.inputdir, 'mars_request.csv')
+        marsfile = os.path.join(c.inputdir, 'mars_requests.csv')
         with open(marsfile, 'w') as f:
             f.write('request_number' + ', ')
